import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
  * Lsungsvorschlag zu GKInf / Einfache Programme / Schleifen / Aufg. 5
  * Primzahltest, Teil b)
  *
  * Optimierte Primzahlsuche:
  * 1) Die Zahl 2 ist die einzige gerade Primzahl, alle anderen geraden
  *    Zahlen sind keine Primzahlen, weil teilbar durch 2. Also kommen
  *    als Primzahlen auer 2 nur noch ungerade natrliche Zahlen in Frage.
  * 2) Wenn t ein Teiler von n ist, dann ist auch t' = (n/t) ein Teiler
  *    von n. Dann gilt: t*t' = n. Also folgt: wenn t > Sqrt(n) ist, dann
  *    ist t' < Sqrt(n). Also muss man nur im Bereich [2..Sqrt(2)] nach
  *    Teilern suchen; wenn dort keine gefunden werden, gibt es keine.
  * 3) Jede dritte ungerade Zahl ist durch 3 teilbar und kommt damit nicht
  *    mehr als mglicher Teiler von n in Frage, weil dann ja schon die
  *    Teilbarkeit von n durch 3 zuvor htte entdeckt werden mssen!
  *
  * @version 1.0 vom 04.01.2012
  * @author Roland Mechling
  */

public class primtest extends JFrame {
  // Anfang Attribute
  private TextField textField1 = new TextField();
  private Label label1 = new Label();
  private Button button1 = new Button();
  private TextField textField3 = new TextField();
  // Ende Attribute

  public primtest(String title) {
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 299; 
    int frameHeight = 183;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    setResizable(false);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    textField1.setBounds(104, 24, 177, 25);
    textField1.setEditable(true);
    cp.add(textField1);
    label1.setBounds(16, 24, 83, 25);
    label1.setText("Nat. Zahl  n :");
    cp.add(label1);
    button1.setBounds(16, 64, 265, 33);
    button1.setLabel("Auf 'Primzahl?' testen");
    button1.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        button1_ActionPerformed(evt);
      }
    });
    cp.add(button1);
    textField3.setBounds(16, 104, 265, 25);
    textField3.setEditable(false);
    cp.add(textField3);
    setTitle("Primzahl-Test");
    // Ende Komponenten

    setVisible(true);
  }

  // Anfang Methoden
  public void button1_ActionPerformed(ActionEvent evt) {
    /* Eingabe */
    int n  = Integer.parseInt(textField1.getText());
    int g  = (int) Math.rint(Math.sqrt(n)) + 1;
    int tt = 2, c = 0;

    /* Verarbeitung */
    if (n % tt > 0) {
      tt = 3;
      while ((tt < n) && (n % tt > 0)) {
        if (c == 2) {
          tt = tt + 4;
          c = 0;
        } else {
          tt = tt + 2;
          c = c + 1;
        }
      }
    }

    /* Ausgabe */
    if ((tt < n) && (n % tt == 0)) {
      textField3.setText("...ist teilbar durch " + Integer.toString(tt));
    } else {
      if (n == 1) {
        textField3.setText("...ist keine Primzahl!");
      } else {
        textField3.setText("...ist eine Primzahl!");
      }

    }
  }

  // Ende Methoden

  public static void main(String[] args) {
    new primtest("input_test1");
  }
}
